#include "basic.h"
#include "vsm.h"
#include "re2c.h"
#include "bison2.h"
#include "libmy/mode3.h"
#include "libmy/mt19937ar.h"


//---------------------------------------------------------------------------
ST_BASIC_COLOR BasicColor[BASIC_MAX_COLOR_CNT] = {
	{ RGB5( 0,  0,  0) },		//
	{ RGB5( 0,  0, 31) },		//
	{ RGB5(31,  0,  0) },		//
	{ RGB5(13,  0, 13) },		//
	{ RGB5( 0, 13,  0) },		//
	{ RGB5( 0, 31, 31) },		//
	{ RGB5( 0, 31, 31) },		//
	{ RGB5(31, 31, 31) },		//
};


//---------------------------------------------------------------------------
ROM_CODE void BasicInit(char* pBuf)
{
	Re2cInit(pBuf);
	BisonInit();

	VsmInit();
}
//---------------------------------------------------------------------------
ROM_CODE bool BasicParse()
{
	if(yyparse() != 0)
	{
		return FALSE;
	}

	VsmReset();
	return TRUE;
}
//---------------------------------------------------------------------------
ROM_CODE void BasicExec()
{
	VsmExec();
}
//---------------------------------------------------------------------------
ROM_CODE bool BasicIsEnd()
{
	return VsmIsExecEnd();
}
//---------------------------------------------------------------------------
void BasicDrawLf()
{
	Mode3DrawStrLf("");
}
//---------------------------------------------------------------------------
void BasicDrawStr(char* pStr)
{
	Mode3DrawStr(pStr);
}
//---------------------------------------------------------------------------
void BasicDrawNum(s16 num)
{
	Mode3DrawNum(num);
}
//---------------------------------------------------------------------------
void BasicDrawErrStr(char* pStr, s16 num)
{
	Mode3DrawStr(pStr);
	Mode3DrawStr("in");

	Mode3DrawNum(num);
}
//---------------------------------------------------------------------------
void BasicDrawPset(u16 sx, u16 sy, u16 col)
{
	if(col >= BASIC_MAX_COLOR_CNT) return;

	TRACEOUT("DrawPset: %d-%d, %d\n", sx, sy, col);
	Mode3DrawPset(sx, sy, BasicColor[col].hex);
}
//---------------------------------------------------------------------------
void BasicDrawLine(u16 sx, u16 sy, u16 ex, u16 ey, u16 col)
{
	if(col >= BASIC_MAX_COLOR_CNT) return;

	TRACEOUT("DrawLine: %d-%d, %d-%d, %d\n", sx, sy, ex, ey, col);
	Mode3DrawLine(sx, sy, ex, ey, BasicColor[col].hex);
}
//---------------------------------------------------------------------------
void BasicDrawCircle(u16 sx, u16 sy, u16 r, u16 col)
{
	if(col >= BASIC_MAX_COLOR_CNT) return;

	TRACEOUT("DrawCiecle: %d-%d, %d, %d\n", sx, sy, r, col);
	Mode3DrawCircle(sx, sy, r, BasicColor[col].hex);
}
//---------------------------------------------------------------------------
u16 BasicGetRand(u16 num)
{
	return _Rand(num);
}
