#include "re2c.h"
#include "bison2.h"


//---------------------------------------------------------------------------
ST_RE2C Re2c;
char*   yyin;
char*   yyold;
char*   yymarker;


//---------------------------------------------------------------------------
void Re2cInit(char* pSrc)
{
	_Memset(&Re2c, 0x00, sizeof(ST_RE2C));

	yyin = pSrc;
}
//---------------------------------------------------------------------------
void Re2cSkipLF()
{
	char ch;

	for(;;)
	{
		ch = *yyin++;

		if(ch == 0x0a || ch == '\0')		// 0x0a = LF
		{
			yyin--;
			return;
		}
	}
}
//---------------------------------------------------------------------------
void Re2cBufClear()
{
	Re2c.cnt = 0;
}
//---------------------------------------------------------------------------
bool Re2cBufFill()
{
	char* pCh  = yyold;
	s16   size = yyin - yyold;
	s16   i;

	if(Re2c.cnt+size+1 >= RE2C_MAX_BUF_CNT)
	{
		return FALSE;
	}

	if(size+1 >= RE2C_MAX_STR_CNT)
	{
		return FALSE;
	}

	// bisonɊi[m点܂
	yylval = &Re2c.buf[Re2c.cnt];

	for(i=0; i<size; i++)
	{
		Re2c.buf[Re2c.cnt++] = *pCh++;
	}
	Re2c.buf[Re2c.cnt++] = '\0';


	return TRUE;
}
//---------------------------------------------------------------------------
int yylex()
{
start:
	yyold = yyin;


/*!re2c
	ws		=	[\r\t ]+;
	lf		=	[\n];
	digit	=	[0-9]+;
	letter	=	[a-zA-Z_];
	var		=	letter(letter | digit | '.')*;
	str		=	('"')([^"])*('"');
	other	=	.;

	re2c:define:YYCTYPE  = "char";
	re2c:define:YYCURSOR = yyin;
	re2c:yyfill:enable   = 0;
	re2c:indent:top      = 1;

	'IF'		{ return TOKEN_IF;     }
	'THEN'		{ return TOKEN_THEN;   }
	'GOTO'		{ return TOKEN_GOTO;   }
	'ELSE'		{ return TOKEN_ELSE;   }
	'FOR'		{ return TOKEN_FOR;    }
	'TO'		{ return TOKEN_TO;     }
	'NEXT'		{ return TOKEN_NEXT;   }
	'PRINT'		{ return TOKEN_PRINT;  }
	'GOSUB'		{ return TOKEN_GOSUB;  }
	'RETURN'	{ return TOKEN_RETURN; }
	'CLS'		{ return TOKEN_CLS;    }
	'PSET'		{ return TOKEN_PSET;   }
	'LINE'		{ return TOKEN_LINE;   }
	'CIRCLE'	{ return TOKEN_CIRCLE; }
	'DIM'		{ return TOKEN_DIM;    }
	'RND'		{ return TOKEN_RND;    }
	'REM'		{ return TOKEN_REM;    }
	'END'		{ return TOKEN_END;    }

	'+'			{ return TOKEN_PLUS;   }
	'-'			{ return TOKEN_MINUS;  }
	'*'			{ return TOKEN_MULT;   }
	'/'			{ return TOKEN_DIV;    }
	'MOD'		{ return TOKEN_MOD;    }

	'>='		{ return TOKEN_GE;     }
	'>'			{ return TOKEN_GT;     }
	'<='		{ return TOKEN_LE;     }
	'<'			{ return TOKEN_LT;     }
	'='			{ return TOKEN_EQ;     }
	'<>'		{ return TOKEN_NE;     }

	'('			{ return TOKEN_LPAR;   }
	')'			{ return TOKEN_RPAR;   }
	','			{ return TOKEN_COMMA;  }
	';'			{ return TOKEN_SEMI;   }
	':'			{ return TOKEN_COLON;  }

	'NOT'		{ return TOKEN_NOT;    }
	'AND'		{ return TOKEN_AND;    }
	'OR'		{ return TOKEN_OR;     }
	'XOR'		{ return TOKEN_XOR;    }

	digit		{ return (Re2cBufFill() == TRUE) ? TOKEN_NUM : TOKEN_ERR; }
	var			{ return (Re2cBufFill() == TRUE) ? TOKEN_VAR : TOKEN_ERR; }
	str			{ return (Re2cBufFill() == TRUE) ? TOKEN_STR : TOKEN_ERR; }
	lf			{ return TOKEN_LF;     }
	ws			{ goto start;          }
	other		{ return 0;            }
*/
}
