#include "game.h"
#include "menu.h"
#include "basic.h"
#include "libmy/mode3.h"
#include "libmy/key.h"

//---------------------------------------------------------------------------
ST_GAME Game;


//---------------------------------------------------------------------------
EWRAM_CODE void GameInit()
{
	Game.state = GAME_INIT;
}
//---------------------------------------------------------------------------
EWRAM_CODE void GameExec()
{
	u16 key = KeyGetCnt();


	switch(Game.state)
	{
	case GAME_INIT:
		MenuInit();
		Game.state = GAME_SEL;
		break;

	case GAME_SEL:
		MenuExec();

		if(MenuIsEnd() == TRUE)
		{
			MenuCls();
			BasicInit(MenuGetFilePointer());
			BasicParse();

			Game.state = GAME_RUN;
		}
		break;

	case GAME_RUN:
		BasicExec();

		if((BasicIsEnd() == TRUE) || (key & KEY_B))
		{
			Game.state = GAME_RESTART;
		}
		break;

	case GAME_RESTART: ;

		if(key & KEY_B)
		{
			MenuRestart();
			Game.state = GAME_SEL;
		}
		break;

	default:
		SystemError("[Err] GameExec State");
		break;
	}
}
//---------------------------------------------------------------------------
EWRAM_CODE void GameDraw()
{

}
