#ifndef __MODE3_H__
#define __MODE3_H__
#ifdef __cplusplus
extern "C" {
#endif


#include "../libgba/gba.h"

//---------------------------------------------------------------------------
#define MODE3_MAX_BUF_SIZE			(SCREEN_WIDTH * SCREEN_HEIGHT * 2)


//---------------------------------------------------------------------------
typedef struct {
	bool isDraw;
	u16* pBuf;

	// Cursor
	s16  curX;
	s16  curY;

	// Ascii
	u16* pDat;
	u16  imgCx;			// tHg̃TCY
	u16  imgCy;
	u16  scnCx;			// tHgo^ł鐔iXN[j
	u16  scnCy;

} ST_MODE3;


//---------------------------------------------------------------------------
EWRAM_CODE void Mode3Init();
EWRAM_CODE void Mode3MallocBuf();
EWRAM_CODE void Mode3FreeBuf();
IWRAM_CODE void Mode3Update();


//----
IWRAM_CODE void Mode3Cls();
IWRAM_CODE void Mode3DrawPset(u16 x, u16 y, u16 col);
IWRAM_CODE void Mode3DrawLine(u16 x1, u16 y1, u16 x2, u16 y2, u16 col);
IWRAM_CODE void Mode3DrawCircle(u16 sx, u16 sy, u16 rad, u16 col);
IWRAM_CODE void Mode3DrawStr(char* str);
IWRAM_CODE void Mode3DrawStrLf(char* str);
IWRAM_CODE void Mode3DrawChr(char chr);
IWRAM_CODE void Mode3DrawNum(s16 num);


//----
EWRAM_CODE u16  Mode3GetScnCy();
EWRAM_CODE u16  Mode3GetImgCy();


#ifdef __cplusplus
}
#endif
#endif
